require '_h2ph_pre.ph';

unless(defined(&_ASM_HW_IRQ_H)) {
    eval 'sub _ASM_HW_IRQ_H () {1;}' unless defined(&_ASM_HW_IRQ_H);
    require 'linux/config.ph';
    require 'asm/irq.ph';
    eval 'sub FIRST_EXTERNAL_VECTOR () {0x20;}' unless defined(&FIRST_EXTERNAL_VECTOR);
    eval 'sub SYSCALL_VECTOR () {0x80;}' unless defined(&SYSCALL_VECTOR);
    eval 'sub SPURIOUS_APIC_VECTOR () {0xff;}' unless defined(&SPURIOUS_APIC_VECTOR);
    eval 'sub ERROR_APIC_VECTOR () {0xfe;}' unless defined(&ERROR_APIC_VECTOR);
    eval 'sub INVALIDATE_TLB_VECTOR () {0xfd;}' unless defined(&INVALIDATE_TLB_VECTOR);
    eval 'sub RESCHEDULE_VECTOR () {0xfc;}' unless defined(&RESCHEDULE_VECTOR);
    eval 'sub CALL_FUNCTION_VECTOR () {0xfb;}' unless defined(&CALL_FUNCTION_VECTOR);
    eval 'sub LOCAL_TIMER_VECTOR () {0xef;}' unless defined(&LOCAL_TIMER_VECTOR);
    eval 'sub FIRST_DEVICE_VECTOR () {0x31;}' unless defined(&FIRST_DEVICE_VECTOR);
    eval 'sub FIRST_SYSTEM_VECTOR () {0xef;}' unless defined(&FIRST_SYSTEM_VECTOR);
    eval 'sub IO_APIC_VECTOR {
        local($irq) = @_;
	    eval q( $irq_vector[$irq]);
    }' unless defined(&IO_APIC_VECTOR);
    eval 'sub IO_APIC_IRQ {
        local($x) = @_;
	    eval q(((($x) >= 16) || ((1<<($x)) &  &io_apic_irqs)));
    }' unless defined(&IO_APIC_IRQ);
    eval 'sub __STR {
        local($x) = @_;
	    eval q($x);
    }' unless defined(&__STR);
    eval 'sub STR {
        local($x) = @_;
	    eval q( &__STR($x));
    }' unless defined(&STR);
    eval 'sub SAVE_ALL () {"cld\\n\\t" "pushl %es\\n\\t" "pushl %ds\\n\\t" "pushl %eax\\n\\t" "pushl %ebp\\n\\t" "pushl %edi\\n\\t" "pushl %esi\\n\\t" "pushl %edx\\n\\t" "pushl %ecx\\n\\t" "pushl %ebx\\n\\t" "movl $"  &STR( &__KERNEL_DS) ",%edx\\n\\t" "movl %edx,%ds\\n\\t" "movl %edx,%es\\n\\t";}' unless defined(&SAVE_ALL);
    eval 'sub IRQ_NAME2 {
        local($nr) = @_;
	    eval q($nr &_interrupt( &void));
    }' unless defined(&IRQ_NAME2);
    eval 'sub IRQ_NAME {
        local($nr) = @_;
	    eval q( &IRQ_NAME2( &IRQ$nr));
    }' unless defined(&IRQ_NAME);
    eval 'sub GET_CURRENT () {"movl %esp, %ebx\\n\\t" "andl $-8192, %ebx\\n\\t";}' unless defined(&GET_CURRENT);
    eval 'sub BUILD_SMP_INTERRUPT {
        local($x,$v) = @_;
	    eval q( &XBUILD_SMP_INTERRUPT($x,$v));
    }' unless defined(&BUILD_SMP_INTERRUPT);
    eval 'sub XBUILD_SMP_INTERRUPT {
        local($x,$v) = @_;
	    eval q( &asmlinkage  &void $x( &void);  &asmlinkage  &void  &call_$x( &void);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR($x) \\":\\\\n\\\\t\\" \\"pushl $\\"$v\\"\\\\n\\\\t\\"  &SAVE_ALL  &SYMBOL_NAME_STR( &call_$x)\\":\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &smp_$x)\\"\\\\n\\\\t\\" \\"jmp ret_from_intr\\\\n\\"););
    }' unless defined(&XBUILD_SMP_INTERRUPT);
    eval 'sub BUILD_SMP_TIMER_INTERRUPT {
        local($x,$v) = @_;
	    eval q( &XBUILD_SMP_TIMER_INTERRUPT($x,$v));
    }' unless defined(&BUILD_SMP_TIMER_INTERRUPT);
    eval 'sub XBUILD_SMP_TIMER_INTERRUPT {
        local($x,$v) = @_;
	    eval q( &asmlinkage  &void $x(\'struct pt_regs\' *  &regs);  &asmlinkage  &void  &call_$x( &void);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR($x) \\":\\\\n\\\\t\\" \\"pushl $\\"$v\\"\\\\n\\\\t\\"  &SAVE_ALL \\"movl %esp,%eax\\\\n\\\\t\\" \\"pushl %eax\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &call_$x)\\":\\\\n\\\\t\\" \\"call \\" &SYMBOL_NAME_STR( &smp_$x)\\"\\\\n\\\\t\\" \\"addl $4,%esp\\\\n\\\\t\\" \\"jmp ret_from_intr\\\\n\\"););
    }' unless defined(&XBUILD_SMP_TIMER_INTERRUPT);
    eval 'sub BUILD_COMMON_IRQ () {
        eval q( &asmlinkage  &void  &call_do_IRQ( &void);  &__asm__( \\"\\\\n\\"  &__ALIGN_STR\\"\\\\n\\" \\"common_interrupt:\\\\n\\\\t\\"  &SAVE_ALL \\"pushl $ret_from_intr\\\\n\\\\t\\"  &SYMBOL_NAME_STR( &call_do_IRQ)\\":\\\\n\\\\t\\" \\"jmp \\" &SYMBOL_NAME_STR( &do_IRQ)););
    }' unless defined(&BUILD_COMMON_IRQ);
    eval 'sub BUILD_IRQ {
        local($nr) = @_;
	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR\\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"pushl $\\"$nr\\"-256\\\\n\\\\t\\" \\"jmp common_interrupt\\"););
    }' unless defined(&BUILD_IRQ);
    if(defined(&CONFIG_SMP)) {
    } else {
    }
}
1;
