require '_h2ph_pre.ph';

unless(defined(&__ASM_I386_PROCESSOR_H)) {
    eval 'sub __ASM_I386_PROCESSOR_H () {1;}' unless defined(&__ASM_I386_PROCESSOR_H);
    require 'asm/vm86.ph';
    require 'asm/math_emu.ph';
    require 'asm/segment.ph';
    require 'asm/page.ph';
    require 'asm/types.ph';
    require 'asm/sigcontext.ph';
    require 'linux/config.ph';
    require 'linux/threads.ph';
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &__asm__(\\"movl $1f,%0\\\\n1:\\":\\"=g\\" ( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    eval 'sub X86_VENDOR_INTEL () {0;}' unless defined(&X86_VENDOR_INTEL);
    eval 'sub X86_VENDOR_CYRIX () {1;}' unless defined(&X86_VENDOR_CYRIX);
    eval 'sub X86_VENDOR_AMD () {2;}' unless defined(&X86_VENDOR_AMD);
    eval 'sub X86_VENDOR_UMC () {3;}' unless defined(&X86_VENDOR_UMC);
    eval 'sub X86_VENDOR_NEXGEN () {4;}' unless defined(&X86_VENDOR_NEXGEN);
    eval 'sub X86_VENDOR_CENTAUR () {5;}' unless defined(&X86_VENDOR_CENTAUR);
    eval 'sub X86_VENDOR_RISE () {6;}' unless defined(&X86_VENDOR_RISE);
    eval 'sub X86_VENDOR_TRANSMETA () {7;}' unless defined(&X86_VENDOR_TRANSMETA);
    eval 'sub X86_VENDOR_UNKNOWN () {0xff;}' unless defined(&X86_VENDOR_UNKNOWN);
    eval 'sub X86_FEATURE_FPU () {0x00000001;}' unless defined(&X86_FEATURE_FPU);
    eval 'sub X86_FEATURE_VME () {0x00000002;}' unless defined(&X86_FEATURE_VME);
    eval 'sub X86_FEATURE_DE () {0x00000004;}' unless defined(&X86_FEATURE_DE);
    eval 'sub X86_FEATURE_PSE () {0x00000008;}' unless defined(&X86_FEATURE_PSE);
    eval 'sub X86_FEATURE_TSC () {0x00000010;}' unless defined(&X86_FEATURE_TSC);
    eval 'sub X86_FEATURE_MSR () {0x00000020;}' unless defined(&X86_FEATURE_MSR);
    eval 'sub X86_FEATURE_PAE () {0x00000040;}' unless defined(&X86_FEATURE_PAE);
    eval 'sub X86_FEATURE_MCE () {0x00000080;}' unless defined(&X86_FEATURE_MCE);
    eval 'sub X86_FEATURE_CX8 () {0x00000100;}' unless defined(&X86_FEATURE_CX8);
    eval 'sub X86_FEATURE_APIC () {0x00000200;}' unless defined(&X86_FEATURE_APIC);
    eval 'sub X86_FEATURE_10 () {0x00000400;}' unless defined(&X86_FEATURE_10);
    eval 'sub X86_FEATURE_SEP () {0x00000800;}' unless defined(&X86_FEATURE_SEP);
    eval 'sub X86_FEATURE_MTRR () {0x00001000;}' unless defined(&X86_FEATURE_MTRR);
    eval 'sub X86_FEATURE_PGE () {0x00002000;}' unless defined(&X86_FEATURE_PGE);
    eval 'sub X86_FEATURE_MCA () {0x00004000;}' unless defined(&X86_FEATURE_MCA);
    eval 'sub X86_FEATURE_CMOV () {0x00008000;}' unless defined(&X86_FEATURE_CMOV);
    eval 'sub X86_FEATURE_PAT () {0x00010000;}' unless defined(&X86_FEATURE_PAT);
    eval 'sub X86_FEATURE_PSE36 () {0x00020000;}' unless defined(&X86_FEATURE_PSE36);
    eval 'sub X86_FEATURE_18 () {0x00040000;}' unless defined(&X86_FEATURE_18);
    eval 'sub X86_FEATURE_19 () {0x00080000;}' unless defined(&X86_FEATURE_19);
    eval 'sub X86_FEATURE_20 () {0x00100000;}' unless defined(&X86_FEATURE_20);
    eval 'sub X86_FEATURE_21 () {0x00200000;}' unless defined(&X86_FEATURE_21);
    eval 'sub X86_FEATURE_22 () {0x00400000;}' unless defined(&X86_FEATURE_22);
    eval 'sub X86_FEATURE_MMX () {0x00800000;}' unless defined(&X86_FEATURE_MMX);
    eval 'sub X86_FEATURE_FXSR () {0x01000000;}' unless defined(&X86_FEATURE_FXSR);
    eval 'sub X86_FEATURE_XMM () {0x02000000;}' unless defined(&X86_FEATURE_XMM);
    eval 'sub X86_FEATURE_26 () {0x04000000;}' unless defined(&X86_FEATURE_26);
    eval 'sub X86_FEATURE_27 () {0x08000000;}' unless defined(&X86_FEATURE_27);
    eval 'sub X86_FEATURE_28 () {0x10000000;}' unless defined(&X86_FEATURE_28);
    eval 'sub X86_FEATURE_29 () {0x20000000;}' unless defined(&X86_FEATURE_29);
    eval 'sub X86_FEATURE_30 () {0x40000000;}' unless defined(&X86_FEATURE_30);
    eval 'sub X86_FEATURE_AMD3D () {0x80000000;}' unless defined(&X86_FEATURE_AMD3D);
    if(defined(&CONFIG_SMP)) {
	eval 'sub current_cpu_data () { $cpu_data[ &smp_processor_id()];}' unless defined(&current_cpu_data);
    } else {
	eval 'sub cpu_data () { &boot_cpu_data;}' unless defined(&cpu_data);
	eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
    }
    eval 'sub cpu_has_pge () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_PGE);}' unless defined(&cpu_has_pge);
    eval 'sub cpu_has_pse () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_PSE);}' unless defined(&cpu_has_pse);
    eval 'sub cpu_has_pae () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_PAE);}' unless defined(&cpu_has_pae);
    eval 'sub cpu_has_tsc () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_TSC);}' unless defined(&cpu_has_tsc);
    eval 'sub cpu_has_de () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_DE);}' unless defined(&cpu_has_de);
    eval 'sub cpu_has_vme () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_VME);}' unless defined(&cpu_has_vme);
    eval 'sub cpu_has_fxsr () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_FXSR);}' unless defined(&cpu_has_fxsr);
    eval 'sub cpu_has_xmm () {( ($boot_cpu_data->{x86_capability}) &  &X86_FEATURE_XMM);}' unless defined(&cpu_has_xmm);
    eval 'sub X86_CR4_VME () {0x0001;}' unless defined(&X86_CR4_VME);
    eval 'sub X86_CR4_PVI () {0x0002;}' unless defined(&X86_CR4_PVI);
    eval 'sub X86_CR4_TSD () {0x0004;}' unless defined(&X86_CR4_TSD);
    eval 'sub X86_CR4_DE () {0x0008;}' unless defined(&X86_CR4_DE);
    eval 'sub X86_CR4_PSE () {0x0010;}' unless defined(&X86_CR4_PSE);
    eval 'sub X86_CR4_PAE () {0x0020;}' unless defined(&X86_CR4_PAE);
    eval 'sub X86_CR4_MCE () {0x0040;}' unless defined(&X86_CR4_MCE);
    eval 'sub X86_CR4_PGE () {0x0080;}' unless defined(&X86_CR4_PGE);
    eval 'sub X86_CR4_PCE () {0x0100;}' unless defined(&X86_CR4_PCE);
    eval 'sub X86_CR4_OSFXSR () {0x0200;}' unless defined(&X86_CR4_OSFXSR);
    eval 'sub X86_CR4_OSXMMEXCPT () {0x0400;}' unless defined(&X86_CR4_OSXMMEXCPT);
    eval 'sub CX86_CCR0 () {0xc0;}' unless defined(&CX86_CCR0);
    eval 'sub CX86_CCR1 () {0xc1;}' unless defined(&CX86_CCR1);
    eval 'sub CX86_CCR2 () {0xc2;}' unless defined(&CX86_CCR2);
    eval 'sub CX86_CCR3 () {0xc3;}' unless defined(&CX86_CCR3);
    eval 'sub CX86_CCR4 () {0xe8;}' unless defined(&CX86_CCR4);
    eval 'sub CX86_CCR5 () {0xe9;}' unless defined(&CX86_CCR5);
    eval 'sub CX86_CCR6 () {0xea;}' unless defined(&CX86_CCR6);
    eval 'sub CX86_DIR0 () {0xfe;}' unless defined(&CX86_DIR0);
    eval 'sub CX86_DIR1 () {0xff;}' unless defined(&CX86_DIR1);
    eval 'sub CX86_ARR_BASE () {0xc4;}' unless defined(&CX86_ARR_BASE);
    eval 'sub CX86_RCR_BASE () {0xdc;}' unless defined(&CX86_RCR_BASE);
    eval 'sub getCx86 {
        local($reg) = @_;
	    eval q(({  &outb(($reg), 0x22);  &inb(0x23); }));
    }' unless defined(&getCx86);
    eval 'sub setCx86 {
        local($reg, $data) = @_;
	    eval q( &do {  &outb(($reg), 0x22);  &outb(($data), 0x23); }  &while (0));
    }' unless defined(&setCx86);
    eval 'sub TASK_SIZE () {( &PAGE_OFFSET);}' unless defined(&TASK_SIZE);
    eval 'sub TASK_UNMAPPED_BASE () {( &TASK_SIZE / 3);}' unless defined(&TASK_UNMAPPED_BASE);
    eval 'sub IO_BITMAP_SIZE () {32;}' unless defined(&IO_BITMAP_SIZE);
    eval 'sub IO_BITMAP_OFFSET () { &offsetof(\'struct tss_struct\', &io_bitmap);}' unless defined(&IO_BITMAP_OFFSET);
    eval 'sub INVALID_IO_BITMAP_OFFSET () {0x8000;}' unless defined(&INVALID_IO_BITMAP_OFFSET);
    eval 'sub INIT_THREAD () {{ 0, 0, 0, 0, 0, { [0... 7] = 0}, 0, 0, 0, { { 0, }, }, 0,0,0,0,0,0, 0,{~0,} };}' unless defined(&INIT_THREAD);
    eval 'sub INIT_MMAP () {{  &init_mm, 0, 0,  &NULL,  &PAGE_SHARED,  &VM_READ |  &VM_WRITE |  &VM_EXEC, 1,  &NULL,  &NULL };}' unless defined(&INIT_MMAP);
    eval 'sub INIT_TSS () {{ 0,0, $sizeof{ &init_stack} +   &init_stack,  &__KERNEL_DS, 0, 0,0,0,0,0,0, 0, 0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,0,0, 0,0,0,0,0,0,  &__LDT(0),0, 0,  &INVALID_IO_BITMAP_OFFSET, {~0, } };}' unless defined(&INIT_TSS);
    eval 'sub start_thread {
        local($regs, $new_eip, $new_esp) = @_;
	    eval q( &do {  &__asm__(\\"movl %0,%%fs ; movl %0,%%gs\\": :\\"r\\" (0));  &set_fs( &USER_DS);  ($regs->{xds}) =  &__USER_DS;  ($regs->{xes}) =  &__USER_DS;  ($regs->{xss}) =  &__USER_DS;  ($regs->{xcs}) =  &__USER_CS;  ($regs->{eip}) = $new_eip;  ($regs->{esp}) = $new_esp; }  &while (0));
    }' unless defined(&start_thread);
    eval 'sub KSTK_EIP {
        local($tsk) = @_;
	    eval q((((4096+($tsk)))[1019]));
    }' unless defined(&KSTK_EIP);
    eval 'sub KSTK_ESP {
        local($tsk) = @_;
	    eval q((((4096+($tsk)))[1022]));
    }' unless defined(&KSTK_ESP);
    eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
    eval 'sub alloc_task_struct () {
        eval q((  &__get_free_pages( &GFP_KERNEL,1)));
    }' unless defined(&alloc_task_struct);
    eval 'sub free_task_struct {
        local($p) = @_;
	    eval q( &free_pages( ($p), 1));
    }' unless defined(&free_task_struct);
    eval 'sub get_task_struct {
        local($tsk) = @_;
	    eval q( &atomic_inc( ($mem_map[&MAP_NR(tsk)]->{count})));
    }' unless defined(&get_task_struct);
    eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
    eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
    eval 'sub MICROCODE_IOCFREE () { &_IO(ord(\'6\'),0);}' unless defined(&MICROCODE_IOCFREE);
}
1;
