require '_h2ph_pre.ph';

require 'linux/config.ph';
unless(defined(&BASE_BAUD)) {
    sub BASE_BAUD () {	( 1843200/ 16);}
}
if(defined(&CONFIG_SERIAL_DETECT_IRQ)) {
    eval 'sub STD_COM_FLAGS () {( &ASYNC_BOOT_AUTOCONF |  &ASYNC_SKIP_TEST |  &ASYNC_AUTO_IRQ);}' unless defined(&STD_COM_FLAGS);
    eval 'sub STD_COM4_FLAGS () {( &ASYNC_BOOT_AUTOCONF |  &ASYNC_AUTO_IRQ);}' unless defined(&STD_COM4_FLAGS);
} else {
    eval 'sub STD_COM_FLAGS () {( &ASYNC_BOOT_AUTOCONF |  &ASYNC_SKIP_TEST);}' unless defined(&STD_COM_FLAGS);
    eval 'sub STD_COM4_FLAGS () { &ASYNC_BOOT_AUTOCONF;}' unless defined(&STD_COM4_FLAGS);
}
if(defined(&CONFIG_SERIAL_MANY_PORTS)) {
    eval 'sub FOURPORT_FLAGS () { &ASYNC_FOURPORT;}' unless defined(&FOURPORT_FLAGS);
    eval 'sub ACCENT_FLAGS () {0;}' unless defined(&ACCENT_FLAGS);
    eval 'sub BOCA_FLAGS () {0;}' unless defined(&BOCA_FLAGS);
    eval 'sub HUB6_FLAGS () {0;}' unless defined(&HUB6_FLAGS);
    eval 'sub RS_TABLE_SIZE () {64;}' unless defined(&RS_TABLE_SIZE);
} else {
    eval 'sub RS_TABLE_SIZE () {1;}' unless defined(&RS_TABLE_SIZE);
}
unless(defined(&C_P)) {
    sub C_P {
	local($card,$port) = @_;
	eval q(((($card)<<6|($port)<<3) + 1));
    }
}
unless(defined(&STD_SERIAL_PORT_DEFNS)) {
    sub STD_SERIAL_PORT_DEFNS () {	{ 0,  &BASE_BAUD, 0x3f8, 4,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x2f8, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x3e8, 4,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x2e8, 3,  &STD_COM4_FLAGS },;}
}
if(defined(&CONFIG_SERIAL_MANY_PORTS)) {
    eval 'sub EXTRA_SERIAL_PORT_DEFNS () {{ 0,  &BASE_BAUD, 0x1a0, 9,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x1a8, 9,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x1b0, 9,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x1b8, 9,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x2a0, 5,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x2a8, 5,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x2b0, 5,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x2b8, 5,  &FOURPORT_FLAGS }, { 0,  &BASE_BAUD, 0x330, 4,  &ACCENT_FLAGS }, { 0,  &BASE_BAUD, 0x338, 4,  &ACCENT_FLAGS }, { 0,  &BASE_BAUD, 0x000, 0, 0}, { 0,  &BASE_BAUD, 0x000, 0, 0}, { 0,  &BASE_BAUD, 0x100, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x108, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x110, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x118, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x120, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x128, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x130, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x138, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x140, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x148, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x150, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x158, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x160, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x168, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x170, 12,  &BOCA_FLAGS }, { 0,  &BASE_BAUD, 0x178, 12,  &BOCA_FLAGS },;}' unless defined(&EXTRA_SERIAL_PORT_DEFNS);
} else {
    eval 'sub EXTRA_SERIAL_PORT_DEFNS () {1;}' unless defined(&EXTRA_SERIAL_PORT_DEFNS);
}
if((defined( &CONFIG_HUB6)  && defined( &CONFIG_SERIAL_MANY_PORTS))) {
    eval 'sub HUB6_SERIAL_PORT_DFNS () {{ 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,0) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,1) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,2) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,3) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,4) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(0,5) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,0) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,1) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,2) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,3) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,4) }, { 0,  &BASE_BAUD, 0x302, 3,  &HUB6_FLAGS,  &C_P(1,5) },;}' unless defined(&HUB6_SERIAL_PORT_DFNS);
} else {
    eval 'sub HUB6_SERIAL_PORT_DFNS () {1;}' unless defined(&HUB6_SERIAL_PORT_DFNS);
}
if(defined(&CONFIG_MCA)) {
    eval 'sub MCA_SERIAL_PORT_DFNS () {{ 0,  &BASE_BAUD, 0x3220, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x3228, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x4220, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x4228, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x5220, 3,  &STD_COM_FLAGS }, { 0,  &BASE_BAUD, 0x5228, 3,  &STD_COM_FLAGS },;}' unless defined(&MCA_SERIAL_PORT_DFNS);
} else {
    eval 'sub MCA_SERIAL_PORT_DFNS () {1;}' unless defined(&MCA_SERIAL_PORT_DFNS);
}
unless(defined(&SERIAL_PORT_DFNS)) {
    sub SERIAL_PORT_DFNS () {	 &STD_SERIAL_PORT_DEFNS  &EXTRA_SERIAL_PORT_DEFNS  &HUB6_SERIAL_PORT_DFNS  &MCA_SERIAL_PORT_DFNS;}
}
1;
