require '_h2ph_pre.ph';

unless(defined(&_LINUX_ACPI_H)) {
    eval 'sub _LINUX_ACPI_H () {1;}' unless defined(&_LINUX_ACPI_H);
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/sched.ph';
	require 'linux/wait.ph';
    }
    eval 'sub ACPI_BIOS_ROM_BASE () {(0x0e0000);}' unless defined(&ACPI_BIOS_ROM_BASE);
    eval 'sub ACPI_BIOS_ROM_END () {(0x100000);}' unless defined(&ACPI_BIOS_ROM_END);
    eval 'sub ACPI_RSDP1_SIG () {0x20445352;}' unless defined(&ACPI_RSDP1_SIG);
    eval 'sub ACPI_RSDP2_SIG () {0x20525450;}' unless defined(&ACPI_RSDP2_SIG);
    eval 'sub ACPI_RSDT_SIG () {0x54445352;}' unless defined(&ACPI_RSDT_SIG);
    eval 'sub ACPI_FACP_SIG () {0x50434146;}' unless defined(&ACPI_FACP_SIG);
    eval 'sub ACPI_DSDT_SIG () {0x54445344;}' unless defined(&ACPI_DSDT_SIG);
    eval 'sub ACPI_FACS_SIG () {0x53434146;}' unless defined(&ACPI_FACS_SIG);
    eval 'sub ACPI_TMR () {0x0001;}' unless defined(&ACPI_TMR);
    eval 'sub ACPI_BM () {0x0010;}' unless defined(&ACPI_BM);
    eval 'sub ACPI_GBL () {0x0020;}' unless defined(&ACPI_GBL);
    eval 'sub ACPI_PWRBTN () {0x0100;}' unless defined(&ACPI_PWRBTN);
    eval 'sub ACPI_SLPBTN () {0x0200;}' unless defined(&ACPI_SLPBTN);
    eval 'sub ACPI_RTC () {0x0400;}' unless defined(&ACPI_RTC);
    eval 'sub ACPI_WAK () {0x8000;}' unless defined(&ACPI_WAK);
    eval 'sub ACPI_SCI_EN () {0x0001;}' unless defined(&ACPI_SCI_EN);
    eval 'sub ACPI_BM_RLD () {0x0002;}' unless defined(&ACPI_BM_RLD);
    eval 'sub ACPI_GBL_RLS () {0x0004;}' unless defined(&ACPI_GBL_RLS);
    eval 'sub ACPI_SLP_TYP0 () {0x0400;}' unless defined(&ACPI_SLP_TYP0);
    eval 'sub ACPI_SLP_TYP1 () {0x0800;}' unless defined(&ACPI_SLP_TYP1);
    eval 'sub ACPI_SLP_TYP2 () {0x1000;}' unless defined(&ACPI_SLP_TYP2);
    eval 'sub ACPI_SLP_EN () {0x2000;}' unless defined(&ACPI_SLP_EN);
    eval 'sub ACPI_SLP_TYP_MASK () {0x1c00;}' unless defined(&ACPI_SLP_TYP_MASK);
    eval 'sub ACPI_SLP_TYP_SHIFT () {10;}' unless defined(&ACPI_SLP_TYP_SHIFT);
    eval 'sub ACPI_TMR_MASK () {0x00ffffff;}' unless defined(&ACPI_TMR_MASK);
    eval 'sub ACPI_TMR_HZ () {3580000;}' unless defined(&ACPI_TMR_HZ);
    eval 'sub ACPI_uS_TO_TMR_TICKS {
        local($val) = @_;
	    eval q(((($val) * ( &ACPI_TMR_HZ / 10000)) / 100));
    }' unless defined(&ACPI_uS_TO_TMR_TICKS);
    eval 'sub ACPI_TMR_TICKS_TO_uS {
        local($ticks) = @_;
	    eval q(((($ticks) * 100) / ( &ACPI_TMR_HZ / 10000)));
    }' unless defined(&ACPI_TMR_TICKS_TO_uS);
    eval 'sub ACPI_ARB_DIS () {0x01;}' unless defined(&ACPI_ARB_DIS);
    eval 'sub ACPI_WBINVD () {0x00000001;}' unless defined(&ACPI_WBINVD);
    eval 'sub ACPI_WBINVD_FLUSH () {0x00000002;}' unless defined(&ACPI_WBINVD_FLUSH);
    eval 'sub ACPI_PROC_C1 () {0x00000004;}' unless defined(&ACPI_PROC_C1);
    eval 'sub ACPI_P_LVL2_UP () {0x00000008;}' unless defined(&ACPI_P_LVL2_UP);
    eval 'sub ACPI_PWR_BUTTON () {0x00000010;}' unless defined(&ACPI_PWR_BUTTON);
    eval 'sub ACPI_SLP_BUTTON () {0x00000020;}' unless defined(&ACPI_SLP_BUTTON);
    eval 'sub ACPI_FIX_RTC () {0x00000040;}' unless defined(&ACPI_FIX_RTC);
    eval 'sub ACPI_RTC_64 () {0x00000080;}' unless defined(&ACPI_RTC_64);
    eval 'sub ACPI_TMR_VAL_EXT () {0x00000100;}' unless defined(&ACPI_TMR_VAL_EXT);
    eval 'sub ACPI_DCK_CAP () {0x00000200;}' unless defined(&ACPI_DCK_CAP);
    eval 'sub ACPI_S4BIOS () {0x00000001;}' unless defined(&ACPI_S4BIOS);
    eval 'sub ACPI_P_CNT () {0x00000000;}' unless defined(&ACPI_P_CNT);
    eval 'sub ACPI_P_LVL2 () {0x00000004;}' unless defined(&ACPI_P_LVL2);
    eval 'sub ACPI_P_LVL3 () {0x00000005;}' unless defined(&ACPI_P_LVL3);
    eval 'sub ACPI_MAX_P_LVL2_LAT () {100;}' unless defined(&ACPI_MAX_P_LVL2_LAT);
    eval 'sub ACPI_MAX_P_LVL3_LAT () {1000;}' unless defined(&ACPI_MAX_P_LVL3_LAT);
    eval 'sub ACPI_INFINITE_LAT () {(~0);}' unless defined(&ACPI_INFINITE_LAT);
    eval 'sub ACPI_SLP_TYP_DISABLED () {(~0);}' unless defined(&ACPI_SLP_TYP_DISABLED);
    eval 'sub ACPI_PIIX4_INT_MODEL () {0x00;}' unless defined(&ACPI_PIIX4_INT_MODEL);
    eval 'sub ACPI_PIIX4_SCI_INT () {0x0009;}' unless defined(&ACPI_PIIX4_SCI_INT);
    eval 'sub ACPI_PIIX4_SMI_CMD () {0x00b2;}' unless defined(&ACPI_PIIX4_SMI_CMD);
    eval 'sub ACPI_PIIX4_ACPI_ENABLE () {0xf0;}' unless defined(&ACPI_PIIX4_ACPI_ENABLE);
    eval 'sub ACPI_PIIX4_ACPI_DISABLE () {0xf1;}' unless defined(&ACPI_PIIX4_ACPI_DISABLE);
    eval 'sub ACPI_PIIX4_S4BIOS_REQ () {0xf2;}' unless defined(&ACPI_PIIX4_S4BIOS_REQ);
    eval 'sub ACPI_PIIX4_PM1_EVT () {0x0000;}' unless defined(&ACPI_PIIX4_PM1_EVT);
    eval 'sub ACPI_PIIX4_PM1_CNT () {0x0004;}' unless defined(&ACPI_PIIX4_PM1_CNT);
    eval 'sub ACPI_PIIX4_S0_MASK () {(0x0005 << 10);}' unless defined(&ACPI_PIIX4_S0_MASK);
    eval 'sub ACPI_PIIX4_S1_MASK () {(0x0004 << 10);}' unless defined(&ACPI_PIIX4_S1_MASK);
    eval 'sub ACPI_PIIX4_S2_MASK () {(0x0003 << 10);}' unless defined(&ACPI_PIIX4_S2_MASK);
    eval 'sub ACPI_PIIX4_S3_MASK () {(0x0002 << 10);}' unless defined(&ACPI_PIIX4_S3_MASK);
    eval 'sub ACPI_PIIX4_S4_MASK () {(0x0001 << 10);}' unless defined(&ACPI_PIIX4_S4_MASK);
    eval 'sub ACPI_PIIX4_S5_MASK () {(0x0000 << 10);}' unless defined(&ACPI_PIIX4_S5_MASK);
    eval 'sub ACPI_PIIX4_PM_TMR () {0x0008;}' unless defined(&ACPI_PIIX4_PM_TMR);
    eval 'sub ACPI_PIIX4_GPE0 () {0x000c;}' unless defined(&ACPI_PIIX4_GPE0);
    eval 'sub ACPI_PIIX4_P_BLK () {0x0010;}' unless defined(&ACPI_PIIX4_P_BLK);
    eval 'sub ACPI_PIIX4_PM1_EVT_LEN () {0x04;}' unless defined(&ACPI_PIIX4_PM1_EVT_LEN);
    eval 'sub ACPI_PIIX4_PM1_CNT_LEN () {0x02;}' unless defined(&ACPI_PIIX4_PM1_CNT_LEN);
    eval 'sub ACPI_PIIX4_PM_TM_LEN () {0x04;}' unless defined(&ACPI_PIIX4_PM_TM_LEN);
    eval 'sub ACPI_PIIX4_GPE0_LEN () {0x04;}' unless defined(&ACPI_PIIX4_GPE0_LEN);
    eval 'sub ACPI_PIIX4_PM2_CNT () {0x0022;}' unless defined(&ACPI_PIIX4_PM2_CNT);
    eval 'sub ACPI_PIIX4_PM2_CNT_LEN () {0x01;}' unless defined(&ACPI_PIIX4_PM2_CNT_LEN);
    eval 'sub ACPI_PIIX4_PMREGMISC () {0x80;}' unless defined(&ACPI_PIIX4_PMREGMISC);
    eval 'sub ACPI_PIIX4_PMIOSE () {0x01;}' unless defined(&ACPI_PIIX4_PMIOSE);
    eval 'sub ACPI_VIA_INT_MODEL () {0x00;}' unless defined(&ACPI_VIA_INT_MODEL);
    eval 'sub ACPI_VIA_SMI_CMD () {0x002f;}' unless defined(&ACPI_VIA_SMI_CMD);
    eval 'sub ACPI_VIA_ACPI_ENABLE () {0xa1;}' unless defined(&ACPI_VIA_ACPI_ENABLE);
    eval 'sub ACPI_VIA_ACPI_DISABLE () {0xa0;}' unless defined(&ACPI_VIA_ACPI_DISABLE);
    eval 'sub ACPI_VIA_PM1_EVT () {0x0000;}' unless defined(&ACPI_VIA_PM1_EVT);
    eval 'sub ACPI_VIA_PM1_CNT () {0x0004;}' unless defined(&ACPI_VIA_PM1_CNT);
    eval 'sub ACPI_VIA_PM_TMR () {0x0008;}' unless defined(&ACPI_VIA_PM_TMR);
    eval 'sub ACPI_VIA_GPE0 () {0x0020;}' unless defined(&ACPI_VIA_GPE0);
    eval 'sub ACPI_VIA_P_BLK () {0x0010;}' unless defined(&ACPI_VIA_P_BLK);
    eval 'sub ACPI_VIA_PM1_EVT_LEN () {0x04;}' unless defined(&ACPI_VIA_PM1_EVT_LEN);
    eval 'sub ACPI_VIA_PM1_CNT_LEN () {0x02;}' unless defined(&ACPI_VIA_PM1_CNT_LEN);
    eval 'sub ACPI_VIA_PM_TM_LEN () {0x04;}' unless defined(&ACPI_VIA_PM_TM_LEN);
    eval 'sub ACPI_VIA_GPE0_LEN () {0x04;}' unless defined(&ACPI_VIA_GPE0_LEN);
    eval 'sub ACPI_VIA_DUTY_OFFSET () {1;}' unless defined(&ACPI_VIA_DUTY_OFFSET);
    eval 'sub ACPI_VIA_DUTY_WIDTH () {3;}' unless defined(&ACPI_VIA_DUTY_WIDTH);
    eval 'sub ACPI_VIA_DAY_ALARM () {0x7d;}' unless defined(&ACPI_VIA_DAY_ALARM);
    eval 'sub ACPI_VIA_MON_ALARM () {0x7e;}' unless defined(&ACPI_VIA_MON_ALARM);
    eval 'sub ACPI_VIA_CENTURY () {0x7f;}' unless defined(&ACPI_VIA_CENTURY);
}
1;
