require '_h2ph_pre.ph';

unless(defined(&_LINUX_MM_H)) {
    eval 'sub _LINUX_MM_H () {1;}' unless defined(&_LINUX_MM_H);
    require 'linux/sched.ph';
    require 'linux/errno.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/string.ph';
	require 'linux/list.ph';
	require 'linux/mmzone.ph';
	require 'asm/page.ph';
	require 'asm/pgtable.ph';
	require 'asm/atomic.ph';
	eval 'sub VM_READ () {0x00000001;}' unless defined(&VM_READ);
	eval 'sub VM_WRITE () {0x00000002;}' unless defined(&VM_WRITE);
	eval 'sub VM_EXEC () {0x00000004;}' unless defined(&VM_EXEC);
	eval 'sub VM_SHARED () {0x00000008;}' unless defined(&VM_SHARED);
	eval 'sub VM_MAYREAD () {0x00000010;}' unless defined(&VM_MAYREAD);
	eval 'sub VM_MAYWRITE () {0x00000020;}' unless defined(&VM_MAYWRITE);
	eval 'sub VM_MAYEXEC () {0x00000040;}' unless defined(&VM_MAYEXEC);
	eval 'sub VM_MAYSHARE () {0x00000080;}' unless defined(&VM_MAYSHARE);
	eval 'sub VM_GROWSDOWN () {0x00000100;}' unless defined(&VM_GROWSDOWN);
	eval 'sub VM_GROWSUP () {0x00000200;}' unless defined(&VM_GROWSUP);
	eval 'sub VM_SHM () {0x00000400;}' unless defined(&VM_SHM);
	eval 'sub VM_DENYWRITE () {0x00000800;}' unless defined(&VM_DENYWRITE);
	eval 'sub VM_EXECUTABLE () {0x00001000;}' unless defined(&VM_EXECUTABLE);
	eval 'sub VM_LOCKED () {0x00002000;}' unless defined(&VM_LOCKED);
	eval 'sub VM_IO () {0x00004000;}' unless defined(&VM_IO);
	eval 'sub VM_SEQ_READ () {0x00008000;}' unless defined(&VM_SEQ_READ);
	eval 'sub VM_RAND_READ () {0x00010000;}' unless defined(&VM_RAND_READ);
	eval 'sub VM_DONTCOPY () {0x00020000;}' unless defined(&VM_DONTCOPY);
	eval 'sub VM_STACK_FLAGS () {0x00000177;}' unless defined(&VM_STACK_FLAGS);
	eval 'sub VM_READHINTMASK () {( &VM_SEQ_READ |  &VM_RAND_READ);}' unless defined(&VM_READHINTMASK);
	eval 'sub VM_ClearReadHint {
	    local($v) = @_;
    	    eval q(($v)-> &vm_flags &= ~ &VM_READHINTMASK);
	}' unless defined(&VM_ClearReadHint);
	eval 'sub VM_NormalReadHint {
	    local($v) = @_;
    	    eval q((!(($v)-> &vm_flags &  &VM_READHINTMASK)));
	}' unless defined(&VM_NormalReadHint);
	eval 'sub VM_SequentialReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_SEQ_READ));
	}' unless defined(&VM_SequentialReadHint);
	eval 'sub VM_RandomReadHint {
	    local($v) = @_;
    	    eval q((($v)-> &vm_flags &  &VM_RAND_READ));
	}' unless defined(&VM_RandomReadHint);
	eval 'sub get_page {
	    local($p) = @_;
    	    eval q( &atomic_inc(($p)-> &count));
	}' unless defined(&get_page);
	eval 'sub put_page {
	    local($p) = @_;
    	    eval q( &__free_page($p));
	}' unless defined(&put_page);
	eval 'sub put_page_testzero {
	    local($p) = @_;
    	    eval q( &atomic_dec_and_test(($p)-> &count));
	}' unless defined(&put_page_testzero);
	eval 'sub page_count {
	    local($p) = @_;
    	    eval q( &atomic_read(($p)-> &count));
	}' unless defined(&page_count);
	eval 'sub set_page_count {
	    local($p,$v) = @_;
    	    eval q( &atomic_set(($p)-> &count, $v));
	}' unless defined(&set_page_count);
	eval 'sub PG_locked () {0;}' unless defined(&PG_locked);
	eval 'sub PG_error () {1;}' unless defined(&PG_error);
	eval 'sub PG_referenced () {2;}' unless defined(&PG_referenced);
	eval 'sub PG_uptodate () {3;}' unless defined(&PG_uptodate);
	eval 'sub PG_dirty () {4;}' unless defined(&PG_dirty);
	eval 'sub PG_decr_after () {5;}' unless defined(&PG_decr_after);
	eval 'sub PG_unused_01 () {6;}' unless defined(&PG_unused_01);
	eval 'sub PG__unused_02 () {7;}' unless defined(&PG__unused_02);
	eval 'sub PG_slab () {8;}' unless defined(&PG_slab);
	eval 'sub PG_swap_cache () {9;}' unless defined(&PG_swap_cache);
	eval 'sub PG_skip () {10;}' unless defined(&PG_skip);
	eval 'sub PG_unused_03 () {11;}' unless defined(&PG_unused_03);
	eval 'sub PG_highmem () {12;}' unless defined(&PG_highmem);
	eval 'sub PG_reserved () {31;}' unless defined(&PG_reserved);
	eval 'sub Page_Uptodate {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&Page_Uptodate);
	eval 'sub SetPageUptodate {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&SetPageUptodate);
	eval 'sub ClearPageUptodate {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_uptodate, ($page)-> &flags));
	}' unless defined(&ClearPageUptodate);
	eval 'sub PageDirty {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&PageDirty);
	eval 'sub SetPageDirty {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&SetPageDirty);
	eval 'sub ClearPageDirty {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_dirty, ($page)-> &flags));
	}' unless defined(&ClearPageDirty);
	eval 'sub PageLocked {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&PageLocked);
	eval 'sub LockPage {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&LockPage);
	eval 'sub TryLockPage {
	    local($page) = @_;
    	    eval q( &test_and_set_bit( &PG_locked, ($page)-> &flags));
	}' unless defined(&TryLockPage);
	eval 'sub UnlockPage {
	    local($page) = @_;
    	    eval q( &do {  &clear_bit( &PG_locked, ($page)-> &flags);  &wake_up( ($page->{wait})); }  &while (0));
	}' unless defined(&UnlockPage);
	eval 'sub PageError {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&PageError);
	eval 'sub SetPageError {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&SetPageError);
	eval 'sub ClearPageError {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_error, ($page)-> &flags));
	}' unless defined(&ClearPageError);
	eval 'sub PageReferenced {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&PageReferenced);
	eval 'sub SetPageReferenced {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&SetPageReferenced);
	eval 'sub PageTestandClearReferenced {
	    local($page) = @_;
    	    eval q( &test_and_clear_bit( &PG_referenced, ($page)-> &flags));
	}' unless defined(&PageTestandClearReferenced);
	eval 'sub PageDecrAfter {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_decr_after, ($page)-> &flags));
	}' unless defined(&PageDecrAfter);
	eval 'sub SetPageDecrAfter {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_decr_after, ($page)-> &flags));
	}' unless defined(&SetPageDecrAfter);
	eval 'sub PageTestandClearDecrAfter {
	    local($page) = @_;
    	    eval q( &test_and_clear_bit( &PG_decr_after, ($page)-> &flags));
	}' unless defined(&PageTestandClearDecrAfter);
	eval 'sub PageSlab {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageSlab);
	eval 'sub PageSwapCache {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageSwapCache);
	eval 'sub PageReserved {
	    local($page) = @_;
    	    eval q( &test_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&PageReserved);
	eval 'sub PageSetSlab {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageSetSlab);
	eval 'sub PageSetSwapCache {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageSetSwapCache);
	eval 'sub PageTestandSetSwapCache {
	    local($page) = @_;
    	    eval q( &test_and_set_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageTestandSetSwapCache);
	eval 'sub PageClearSlab {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_slab, ($page)-> &flags));
	}' unless defined(&PageClearSlab);
	eval 'sub PageClearSwapCache {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageClearSwapCache);
	eval 'sub PageTestandClearSwapCache {
	    local($page) = @_;
    	    eval q( &test_and_clear_bit( &PG_swap_cache, ($page)-> &flags));
	}' unless defined(&PageTestandClearSwapCache);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub PageHighMem {
	        local($page) = @_;
    		eval q( &test_bit( &PG_highmem, ($page)-> &flags));
	    }' unless defined(&PageHighMem);
	} else {
	    eval 'sub PageHighMem {
	        local($page) = @_;
    		eval q(0);
	    }' unless defined(&PageHighMem);
	}
	eval 'sub SetPageReserved {
	    local($page) = @_;
    	    eval q( &set_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&SetPageReserved);
	eval 'sub ClearPageReserved {
	    local($page) = @_;
    	    eval q( &clear_bit( &PG_reserved, ($page)-> &flags));
	}' unless defined(&ClearPageReserved);
	eval 'sub NOPAGE_SIGBUS () {( &NULL);}' unless defined(&NOPAGE_SIGBUS);
	eval 'sub NOPAGE_OOM () {( (-1));}' unless defined(&NOPAGE_OOM);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	} else {
	}
	eval 'sub alloc_page {
	    local($gfp_mask) = @_;
    	    eval q( &alloc_pages($gfp_mask, 0));
	}' unless defined(&alloc_page);
	eval 'sub __get_free_page {
	    local($gfp_mask) = @_;
    	    eval q( &__get_free_pages(($gfp_mask),0));
	}' unless defined(&__get_free_page);
	eval 'sub __get_dma_pages {
	    local($gfp_mask, $order) = @_;
    	    eval q( &__get_free_pages(($gfp_mask) |  &GFP_DMA,($order)));
	}' unless defined(&__get_dma_pages);
	eval 'sub get_free_page () { &get_zeroed_page;}' unless defined(&get_free_page);
	eval 'sub __free_page {
	    local($page) = @_;
    	    eval q( &__free_pages($page, 0));
	}' unless defined(&__free_page);
	if(defined(&CONFIG_DISCONTIGMEM)) {
	}
	eval 'sub free_page {
	    local($addr) = @_;
    	    eval q( &free_pages(($addr),0));
	}' unless defined(&free_page);
	eval 'sub __GFP_WAIT () {0x01;}' unless defined(&__GFP_WAIT);
	eval 'sub __GFP_HIGH () {0x02;}' unless defined(&__GFP_HIGH);
	eval 'sub __GFP_IO () {0x04;}' unless defined(&__GFP_IO);
	eval 'sub __GFP_DMA () {0x08;}' unless defined(&__GFP_DMA);
	if(defined(&CONFIG_HIGHMEM)) {
	    eval 'sub __GFP_HIGHMEM () {0x10;}' unless defined(&__GFP_HIGHMEM);
	} else {
	    eval 'sub __GFP_HIGHMEM () {0x0;}' unless defined(&__GFP_HIGHMEM);
	}
	eval 'sub GFP_BUFFER () {( &__GFP_HIGH |  &__GFP_WAIT);}' unless defined(&GFP_BUFFER);
	eval 'sub GFP_ATOMIC () {( &__GFP_HIGH);}' unless defined(&GFP_ATOMIC);
	eval 'sub GFP_USER () {( &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_USER);
	eval 'sub GFP_HIGHUSER () {( &GFP_USER |  &__GFP_HIGHMEM);}' unless defined(&GFP_HIGHUSER);
	eval 'sub GFP_KERNEL () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_KERNEL);
	eval 'sub GFP_NFS () {( &__GFP_HIGH |  &__GFP_WAIT |  &__GFP_IO);}' unless defined(&GFP_NFS);
	eval 'sub GFP_KSWAPD () {( &__GFP_IO);}' unless defined(&GFP_KSWAPD);
	eval 'sub GFP_DMA () { &__GFP_DMA;}' unless defined(&GFP_DMA);
	eval 'sub GFP_HIGHMEM () { &__GFP_HIGHMEM;}' unless defined(&GFP_HIGHMEM);
	eval 'sub buffer_under_min () {
	    eval q(( &atomic_read( &buffermem_pages) * 100<  ($buffer_mem->{min_percent}) *  &num_physpages));
	}' unless defined(&buffer_under_min);
	eval 'sub pgcache_under_min () {
	    eval q(( &atomic_read( &page_cache_size) * 100<  ($page_cache->{min_percent}) *  &num_physpages));
	}' unless defined(&pgcache_under_min);
	eval 'sub vmlist_access_lock {
	    local($mm) = @_;
    	    eval q( &spin_lock( ($mm->{page_table_lock})));
	}' unless defined(&vmlist_access_lock);
	eval 'sub vmlist_access_unlock {
	    local($mm) = @_;
    	    eval q( &spin_unlock( ($mm->{page_table_lock})));
	}' unless defined(&vmlist_access_unlock);
	eval 'sub vmlist_modify_lock {
	    local($mm) = @_;
    	    eval q( &vmlist_access_lock($mm));
	}' unless defined(&vmlist_modify_lock);
	eval 'sub vmlist_modify_unlock {
	    local($mm) = @_;
    	    eval q( &vmlist_access_unlock($mm));
	}' unless defined(&vmlist_modify_unlock);
    }
}
1;
