require '_h2ph_pre.ph';

unless(defined(&_LINUX_SWAP_H)) {
    eval 'sub _LINUX_SWAP_H () {1;}' unless defined(&_LINUX_SWAP_H);
    require 'linux/spinlock.ph';
    require 'asm/page.ph';
    eval 'sub SWAP_FLAG_PREFER () {0x8000;}' unless defined(&SWAP_FLAG_PREFER);
    eval 'sub SWAP_FLAG_PRIO_MASK () {0x7fff;}' unless defined(&SWAP_FLAG_PRIO_MASK);
    eval 'sub SWAP_FLAG_PRIO_SHIFT () {0;}' unless defined(&SWAP_FLAG_PRIO_SHIFT);
    eval 'sub MAX_SWAPFILES () {8;}' unless defined(&MAX_SWAPFILES);
    if(defined(&__KERNEL__)) {
	eval 'sub __swapoffset {
	    local($x) = @_;
    	    eval q(((0)->$x));
	}' unless defined(&__swapoffset);
	eval 'sub MAX_SWAP_BADPAGES () {(( &__swapoffset( ($magic->{magic})) -  &__swapoffset( ($info->{badpages}))) / $sizeof{\'int\'});}' unless defined(&MAX_SWAP_BADPAGES);
	require 'asm/atomic.ph';
	eval 'sub SWP_USED () {1;}' unless defined(&SWP_USED);
	eval 'sub SWP_WRITEOK () {3;}' unless defined(&SWP_WRITEOK);
	eval 'sub SWAP_CLUSTER_MAX () {32;}' unless defined(&SWAP_CLUSTER_MAX);
	eval 'sub SWAP_MAP_MAX () {0x7fff;}' unless defined(&SWAP_MAP_MAX);
	eval 'sub SWAP_MAP_BAD () {0x8000;}' unless defined(&SWAP_MAP_BAD);
	eval 'sub read_swap_cache {
	    local($entry) = @_;
    	    eval q( &read_swap_cache_async($entry, 1););
	}' unless defined(&read_swap_cache);
	eval 'sub get_swap_page () {
	    eval q( &__get_swap_page(1));
	}' unless defined(&get_swap_page);
	eval 'sub swap_free {
	    local($entry) = @_;
    	    eval q( &__swap_free(($entry), 1));
	}' unless defined(&swap_free);
	eval 'sub SWAP_CACHE_INFO () {1;}' unless defined(&SWAP_CACHE_INFO);
	if(defined(&SWAP_CACHE_INFO)) {
	}
	eval 'sub lru_cache_add {
	    local($page) = @_;
    	    eval q( &do {  &spin_lock( &pagemap_lru_lock);  &list_add(($page)-> &lru,  &lru_cache);  &nr_lru_pages++;  &spin_unlock( &pagemap_lru_lock); }  &while (0));
	}' unless defined(&lru_cache_add);
	eval 'sub __lru_cache_del {
	    local($page) = @_;
    	    eval q( &do {  &list_del(($page)-> &lru);  &nr_lru_pages--; }  &while (0));
	}' unless defined(&__lru_cache_del);
	eval 'sub lru_cache_del {
	    local($page) = @_;
    	    eval q( &do {  &if (! &PageLocked($page))  &BUG();  &spin_lock( &pagemap_lru_lock);  &__lru_cache_del($page);  &spin_unlock( &pagemap_lru_lock); }  &while (0));
	}' unless defined(&lru_cache_del);
	eval 'sub swap_list_lock () {
	    eval q( &spin_lock( &swaplock));
	}' unless defined(&swap_list_lock);
	eval 'sub swap_list_unlock () {
	    eval q( &spin_unlock( &swaplock));
	}' unless defined(&swap_list_unlock);
	eval 'sub swap_device_lock {
	    local($p) = @_;
    	    eval q( &spin_lock( ($p->{sdev_lock})));
	}' unless defined(&swap_device_lock);
	eval 'sub swap_device_unlock {
	    local($p) = @_;
    	    eval q( &spin_unlock( ($p->{sdev_lock})));
	}' unless defined(&swap_device_unlock);
    }
}
1;
