require '_h2ph_pre.ph';

unless(defined(&_LINUX_WAIT_H)) {
    eval 'sub _LINUX_WAIT_H () {1;}' unless defined(&_LINUX_WAIT_H);
    eval 'sub WNOHANG () {0x00000001;}' unless defined(&WNOHANG);
    eval 'sub WUNTRACED () {0x00000002;}' unless defined(&WUNTRACED);
    eval 'sub __WALL () {0x40000000;}' unless defined(&__WALL);
    eval 'sub __WCLONE () {0x80000000;}' unless defined(&__WCLONE);
    if(defined(&__KERNEL__)) {
	require 'linux/kernel.ph';
	require 'linux/list.ph';
	require 'linux/stddef.ph';
	require 'linux/spinlock.ph';
	require 'asm/page.ph';
	require 'asm/processor.ph';
	eval 'sub WAITQUEUE_DEBUG () {0;}' unless defined(&WAITQUEUE_DEBUG);
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	    eval 'sub WQ_BUG () {
	        eval q( &do {  &printk(\\"wq bug, forcing oops.\\\\n\\");  &BUG(); }  &while (0));
	    }' unless defined(&WQ_BUG);
	    eval 'sub CHECK_MAGIC {
	        local($x) = @_;
    		eval q( &if ($x != ) {  &printk(\\"bad magic %lx (should be %lx), \\", $x, ($x));  &WQ_BUG(); });
	    }' unless defined(&CHECK_MAGIC);
	    eval 'sub CHECK_MAGIC_WQHEAD {
	        local($x) = @_;
    		eval q( &do {  &if ( ($x->{__magic}) != ( ($x->{__magic}))) {  &printk(\\"bad magic %lx (should be %lx, creator %lx), \\",  ($x->{__magic}), ( ($x->{__magic})),  ($x->{__creator}));  &WQ_BUG(); } }  &while (0));
	    }' unless defined(&CHECK_MAGIC_WQHEAD);
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	eval 'sub USE_RW_WAIT_QUEUE_SPINLOCK () {0;}' unless defined(&USE_RW_WAIT_QUEUE_SPINLOCK);
	if((defined(&USE_RW_WAIT_QUEUE_SPINLOCK) ? &USE_RW_WAIT_QUEUE_SPINLOCK : 0)) {
	    eval 'sub wq_lock_t () { &rwlock_t;}' unless defined(&wq_lock_t);
	    eval 'sub WAITQUEUE_RW_LOCK_UNLOCKED () { &RW_LOCK_UNLOCKED;}' unless defined(&WAITQUEUE_RW_LOCK_UNLOCKED);
	    eval 'sub wq_read_lock () { &read_lock;}' unless defined(&wq_read_lock);
	    eval 'sub wq_read_lock_irqsave () { &read_lock_irqsave;}' unless defined(&wq_read_lock_irqsave);
	    eval 'sub wq_read_unlock_irqrestore () { &read_unlock_irqrestore;}' unless defined(&wq_read_unlock_irqrestore);
	    eval 'sub wq_read_unlock () { &read_unlock;}' unless defined(&wq_read_unlock);
	    eval 'sub wq_write_lock_irq () { &write_lock_irq;}' unless defined(&wq_write_lock_irq);
	    eval 'sub wq_write_lock_irqsave () { &write_lock_irqsave;}' unless defined(&wq_write_lock_irqsave);
	    eval 'sub wq_write_unlock_irqrestore () { &write_unlock_irqrestore;}' unless defined(&wq_write_unlock_irqrestore);
	    eval 'sub wq_write_unlock () { &write_unlock;}' unless defined(&wq_write_unlock);
	} else {
	    eval 'sub wq_lock_t () { &spinlock_t;}' unless defined(&wq_lock_t);
	    eval 'sub WAITQUEUE_RW_LOCK_UNLOCKED () { &SPIN_LOCK_UNLOCKED;}' unless defined(&WAITQUEUE_RW_LOCK_UNLOCKED);
	    eval 'sub wq_read_lock () { &spin_lock;}' unless defined(&wq_read_lock);
	    eval 'sub wq_read_lock_irqsave () { &spin_lock_irqsave;}' unless defined(&wq_read_lock_irqsave);
	    eval 'sub wq_read_unlock () { &spin_unlock;}' unless defined(&wq_read_unlock);
	    eval 'sub wq_read_unlock_irqrestore () { &spin_unlock_irqrestore;}' unless defined(&wq_read_unlock_irqrestore);
	    eval 'sub wq_write_lock_irq () { &spin_lock_irq;}' unless defined(&wq_write_lock_irq);
	    eval 'sub wq_write_lock_irqsave () { &spin_lock_irqsave;}' unless defined(&wq_write_lock_irqsave);
	    eval 'sub wq_write_unlock_irqrestore () { &spin_unlock_irqrestore;}' unless defined(&wq_write_unlock_irqrestore);
	    eval 'sub wq_write_unlock () { &spin_unlock;}' unless defined(&wq_write_unlock);
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	    eval 'sub __WAITQUEUE_DEBUG_INIT {
	        local($name) = @_;
    		eval q(, ($name). &__magic, 0);
	    }' unless defined(&__WAITQUEUE_DEBUG_INIT);
	    eval 'sub __WAITQUEUE_HEAD_DEBUG_INIT {
	        local($name) = @_;
    		eval q(, ($name). &__magic, ($name). &__magic);
	    }' unless defined(&__WAITQUEUE_HEAD_DEBUG_INIT);
	} else {
	    eval 'sub __WAITQUEUE_DEBUG_INIT {
	        local($name) = @_;
    		eval q();
	    }' unless defined(&__WAITQUEUE_DEBUG_INIT);
	    eval 'sub __WAITQUEUE_HEAD_DEBUG_INIT {
	        local($name) = @_;
    		eval q();
	    }' unless defined(&__WAITQUEUE_HEAD_DEBUG_INIT);
	}
	eval 'sub __WAITQUEUE_INITIALIZER {
	    local($name,$task) = @_;
    	    eval q({ 0x1234567, $task, {  &NULL,  &NULL }  &__WAITQUEUE_DEBUG_INIT($name)});
	}' unless defined(&__WAITQUEUE_INITIALIZER);
	eval 'sub DECLARE_WAITQUEUE {
	    local($name,$task) = @_;
    	    eval q( &wait_queue_t $name =  &__WAITQUEUE_INITIALIZER($name,$task));
	}' unless defined(&DECLARE_WAITQUEUE);
	eval 'sub __WAIT_QUEUE_HEAD_INITIALIZER {
	    local($name) = @_;
    	    eval q({  &WAITQUEUE_RW_LOCK_UNLOCKED, { ($name). &task_list, ($name). &task_list }  &__WAITQUEUE_HEAD_DEBUG_INIT($name)});
	}' unless defined(&__WAIT_QUEUE_HEAD_INITIALIZER);
	eval 'sub DECLARE_WAIT_QUEUE_HEAD {
	    local($name) = @_;
    	    eval q( &wait_queue_head_t $name =  &__WAIT_QUEUE_HEAD_INITIALIZER($name));
	}' unless defined(&DECLARE_WAIT_QUEUE_HEAD);
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
    }
}
1;
